Index: at_extern.h
===================================================================
--- at_extern.h	(.../stable/4/sys/netatalk)	(revision 196046)
+++ at_extern.h	(.../head/sys/netatalk)	(revision 196046)
@@ -1,44 +1,67 @@
-struct mbuf;
-struct sockaddr_at;
+/*-
+ * Copyright (c) 1990,1994 Regents of The University of Michigan.
+ * All Rights Reserved.
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby granted,
+ * provided that the above copyright notice appears in all copies and
+ * that both that copyright notice and this permission notice appear
+ * in supporting documentation, and that the name of The University
+ * of Michigan not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior
+ * permission. This software is supplied as is without expressed or
+ * implied warranties of any kind.
+ *
+ * This product includes software developed by the University of
+ * California, Berkeley and its contributors.
+ *
+ *	Research Systems Unix Group
+ *	The University of Michigan
+ *	c/o Wesley Craig
+ *	535 W. William Street
+ *	Ann Arbor, Michigan
+ *	+1-313-764-2278
+ *	netatalk@umich.edu
+ *
+ * $FreeBSD$
+ */
 
-#ifdef _NET_IF_ARP_H_
-extern timeout_t	aarpprobe;
-extern int	aarpresolve	__P((struct arpcom *,
-					struct mbuf *,
-					struct sockaddr_at *,
-					u_char *));
-extern void	aarpinput	__P(( struct arpcom *, struct mbuf *));
-extern int	at_broadcast	__P((struct sockaddr_at  *));
-#endif
+#ifndef _NETATALK_AT_EXTERN_H_
+#define	_NETATALK_AT_EXTERN_H_
 
-#ifdef _NETATALK_AARP_H_
-extern void	aarptfree	__P((struct aarptab *));
-#endif
+extern struct mtx	aarptab_mtx;
 
+#define	AARPTAB_LOCK()		mtx_lock(&aarptab_mtx)
+#define	AARPTAB_UNLOCK()	mtx_unlock(&aarptab_mtx)
+#define	AARPTAB_LOCK_ASSERT()	mtx_assert(&aarptab_mtx, MA_OWNED)
+#define	AARPTAB_UNLOCK_ASSERT()	mtx_assert(&aarptab_mtx, MA_NOTOWNED)
+
+struct at_ifaddr;
 struct ifnet;
-struct proc;
+struct mbuf;
+struct route;
+struct thread;
+struct sockaddr_at;
 struct socket;
+void		 aarpintr(struct mbuf *);
+void		 aarpprobe(void *arg);
+int		 aarpresolve(struct ifnet *, struct mbuf *,
+		    struct sockaddr_at *, u_char *);
+void		 aarp_clean(void);
+void		 at1intr(struct mbuf *);
+void		 at2intr(struct mbuf *);
+int		 at_broadcast(struct sockaddr_at  *);
+u_short		 at_cksum(struct mbuf *m, int skip);
+int		 at_control(struct socket *so, u_long cmd, caddr_t data,
+		    struct ifnet *ifp, struct thread *td);
+struct at_ifaddr	*at_ifawithnet(struct sockaddr_at *);
+struct at_ifaddr	*at_ifawithnet_locked(struct sockaddr_at  *sat);
 
-extern void	aarp_clean	__P((void));
-extern int	at_control	__P(( struct socket *so,
-					u_long cmd,
-					caddr_t data,
-					struct ifnet *ifp,
-					struct proc *p ));
-extern u_short	at_cksum	__P(( struct mbuf *m, int skip));
-extern void	ddp_init	__P((void ));
-extern struct at_ifaddr *at_ifawithnet	__P((struct sockaddr_at *));
-#ifdef	_NETATALK_DDP_VAR_H_
-extern int	ddp_output	__P((struct mbuf *m, struct socket *so)); 
+int		 at_inithead(void**, int);
+void		 ddp_init(void);
+int		 ddp_output(struct mbuf *m, struct socket *so); 
+int		 ddp_route(struct mbuf *m, struct route *ro);
+struct ddpcb	*ddp_search(struct sockaddr_at *, struct sockaddr_at *,
+		    struct at_ifaddr *);
 
-#endif
-#if	defined (_NETATALK_DDP_VAR_H_) && defined(_NETATALK_AT_VAR_H_)
-extern struct ddpcb  *ddp_search __P((struct sockaddr_at *,
-                                		struct sockaddr_at *,
-						struct at_ifaddr *));
-#endif
-#ifdef _NET_ROUTE_H_
-int     ddp_route( struct mbuf *m, struct route *ro);
-#endif
-
-
+#endif /* !_NETATALK_AT_EXTERN_H_ */
Index: ddp_pcb.h
===================================================================
--- ddp_pcb.h	(.../stable/4/sys/netatalk)	(revision 0)
+++ ddp_pcb.h	(.../head/sys/netatalk)	(revision 196046)
@@ -0,0 +1,84 @@
+/*-
+ * Copyright (c) 2004 Robert N. M. Watson
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ * Copyright (c) 1990, 1994 Regents of The University of Michigan.
+ * All Rights Reserved.
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby granted,
+ * provided that the above copyright notice appears in all copies and
+ * that both that copyright notice and this permission notice appear
+ * in supporting documentation, and that the name of The University
+ * of Michigan not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior
+ * permission. This software is supplied as is without expressed or
+ * implied warranties of any kind.
+ *
+ * This product includes software developed by the University of
+ * California, Berkeley and its contributors.
+ *
+ *	Research Systems Unix Group
+ *	The University of Michigan
+ *	c/o Wesley Craig
+ *	535 W. William Street
+ *	Ann Arbor, Michigan
+ *	+1-313-764-2278
+ *	netatalk@umich.edu
+ *
+ * $FreeBSD$
+ */
+
+#ifndef _NETATALK_DDP_PCB_H_
+#define	_NETATALK_DDP_PCB_H_
+
+int	at_pcballoc(struct socket *so);
+int	at_pcbconnect(struct ddpcb *ddp, struct sockaddr *addr, 
+	    struct thread *td);
+void	at_pcbdetach(struct socket *so, struct ddpcb *ddp);
+void	at_pcbdisconnect(struct ddpcb *ddp);
+int	at_pcbsetaddr(struct ddpcb *ddp, struct sockaddr *addr,
+	    struct thread *td);
+void	at_sockaddr(struct ddpcb *ddp, struct sockaddr **addr);
+
+/* Lock macros for per-pcb locks. */
+#define	DDP_LOCK_INIT(ddp)	mtx_init(&(ddp)->ddp_mtx, "ddp_mtx",	\
+				    NULL, MTX_DEF)
+#define	DDP_LOCK_DESTROY(ddp)	mtx_destroy(&(ddp)->ddp_mtx)
+#define	DDP_LOCK(ddp)		mtx_lock(&(ddp)->ddp_mtx)
+#define	DDP_UNLOCK(ddp)		mtx_unlock(&(ddp)->ddp_mtx)
+#define	DDP_LOCK_ASSERT(ddp)	mtx_assert(&(ddp)->ddp_mtx, MA_OWNED)
+
+/* Lock macros for global pcb list lock. */
+#define	DDP_LIST_LOCK_INIT()	mtx_init(&ddp_list_mtx, "ddp_list_mtx",	\
+				    NULL, MTX_DEF)
+#define	DDP_LIST_LOCK_DESTROY()	mtx_destroy(&ddp_list_mtx)
+#define	DDP_LIST_XLOCK()	mtx_lock(&ddp_list_mtx)
+#define	DDP_LIST_XUNLOCK()	mtx_unlock(&ddp_list_mtx)
+#define	DDP_LIST_XLOCK_ASSERT()	mtx_assert(&ddp_list_mtx, MA_OWNED)
+#define	DDP_LIST_SLOCK()	mtx_lock(&ddp_list_mtx)
+#define	DDP_LIST_SUNLOCK()	mtx_unlock(&ddp_list_mtx)
+#define	DDP_LIST_SLOCK_ASSERT()	mtx_assert(&ddp_list_mtx, MA_OWNED)
+
+#endif /* !_NETATALK_DDP_PCB_H_ */

Index: endian.h
===================================================================
--- endian.h	(.../stable/4/sys/netatalk)	(revision 196046)
+++ endian.h	(.../head/sys/netatalk)	(revision 196046)
@@ -1,4 +1,4 @@
-/*
+/*-
  * Copyright (c) 1990,1991 Regents of The University of Michigan.
  * All Rights Reserved.
  *
@@ -19,6 +19,8 @@
  *	Ann Arbor, Michigan
  *	+1-313-763-0525
  *	netatalk@itd.umich.edu
+ *
+ * $FreeBSD$
  */
 
 #ifndef _ATALK_ENDIAN_H_
Index: at_control.c
===================================================================
--- at_control.c	(.../stable/4/sys/netatalk)	(revision 196046)
+++ at_control.c	(.../head/sys/netatalk)	(revision 196046)
@@ -1,14 +1,41 @@
-/*
+/*-
  * Copyright (c) 1990,1991 Regents of The University of Michigan.
+ * Copyright (c) 2009 Robert N. M. Watson
  * All Rights Reserved.
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby granted,
+ * provided that the above copyright notice appears in all copies and
+ * that both that copyright notice and this permission notice appear
+ * in supporting documentation, and that the name of The University
+ * of Michigan not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior
+ * permission. This software is supplied as is without expressed or
+ * implied warranties of any kind.
+ *
+ * This product includes software developed by the University of
+ * California, Berkeley and its contributors.
+ *
+ *	Research Systems Unix Group
+ *	The University of Michigan
+ *	c/o Wesley Craig
+ *	535 W. William Street
+ *	Ann Arbor, Michigan
+ *	+1-313-764-2278
+ *	netatalk@umich.edu
  */
 
+#include <sys/cdefs.h>
+__FBSDID("$FreeBSD$");
+
 #include <sys/param.h>
 #include <sys/systm.h>
-#include <sys/proc.h>
 #include <sys/sockio.h>
+#include <sys/lock.h>
 #include <sys/malloc.h>
 #include <sys/kernel.h>
+#include <sys/priv.h>
+#include <sys/rwlock.h>
 #include <sys/socket.h>
 #include <net/if.h>
 #include <net/route.h>
@@ -20,311 +47,344 @@
 #include <netatalk/at_var.h>
 #include <netatalk/at_extern.h>
 
-struct at_ifaddr	*at_ifaddr;
+struct rwlock		 at_ifaddr_rw;
+struct at_ifaddrhead	 at_ifaddrhead;
 
-static int aa_dorangeroute(struct ifaddr *ifa,
-			u_int first, u_int last, int cmd);
-static int aa_addsingleroute(struct ifaddr *ifa,
-			struct at_addr *addr, struct at_addr *mask);
-static int aa_delsingleroute(struct ifaddr *ifa,
-			struct at_addr *addr, struct at_addr *mask);
+RW_SYSINIT(at_ifaddr_rw, &at_ifaddr_rw, "at_ifaddr_rw");
+
+static int aa_dorangeroute(struct ifaddr *ifa, u_int first, u_int last,
+	    int cmd);
+static int aa_addsingleroute(struct ifaddr *ifa, struct at_addr *addr,
+	    struct at_addr *mask);
+static int aa_delsingleroute(struct ifaddr *ifa, struct at_addr *addr,
+	    struct at_addr *mask);
 static int aa_dosingleroute(struct ifaddr *ifa, struct at_addr *addr,
-			struct at_addr *mask, int cmd, int flags);
-static int at_scrub( struct ifnet *ifp, struct at_ifaddr *aa );
-static int at_ifinit( struct ifnet *ifp, struct at_ifaddr *aa,
-					struct sockaddr_at *sat );
+	    struct at_addr *mask, int cmd, int flags);
+static int at_scrub(struct ifnet *ifp, struct at_ifaddr *aa);
+static int at_ifinit(struct ifnet *ifp, struct at_ifaddr *aa,
+	    struct sockaddr_at *sat);
 static int aa_claim_addr(struct ifaddr *ifa, struct sockaddr *gw);
 
-# define sateqaddr(a,b)	((a)->sat_len == (b)->sat_len && \
-		    (a)->sat_family == (b)->sat_family && \
-		    (a)->sat_addr.s_net == (b)->sat_addr.s_net && \
-		    (a)->sat_addr.s_node == (b)->sat_addr.s_node )
+#define	sateqaddr(a,b)							\
+	((a)->sat_len == (b)->sat_len &&				\
+	(a)->sat_family == (b)->sat_family &&				\
+	(a)->sat_addr.s_net == (b)->sat_addr.s_net &&			\
+	(a)->sat_addr.s_node == (b)->sat_addr.s_node)
 
 int
-at_control(struct socket *so, u_long cmd, caddr_t data,
-		struct ifnet *ifp, struct proc *p )
+at_control(struct socket *so, u_long cmd, caddr_t data, struct ifnet *ifp,
+    struct thread *td)
 {
-    struct ifreq	*ifr = (struct ifreq *)data;
-    struct sockaddr_at	*sat;
-    struct netrange	*nr;
-    struct at_aliasreq	*ifra = (struct at_aliasreq *)data;
-    struct at_ifaddr	*aa0;
-    struct at_ifaddr	*aa = 0;
-    struct ifaddr	*ifa, *ifa0;
+	struct ifreq *ifr = (struct ifreq *)data;
+	struct sockaddr_at *sat;
+	struct netrange	*nr;
+	struct at_aliasreq *ifra = (struct at_aliasreq *)data;
+	struct at_ifaddr *aa;
+	struct ifaddr *ifa;
+	int error;
 
-    /*
-     * If we have an ifp, then find the matching at_ifaddr if it exists
-     */
-    if ( ifp ) {
-	for ( aa = at_ifaddr; aa; aa = aa->aa_next ) {
-	    if ( aa->aa_ifp == ifp ) break;
-	}
-    }
-
-    /*
-     * In this first switch table we are basically getting ready for
-     * the second one, by getting the atalk-specific things set up
-     * so that they start to look more similar to other protocols etc.
-     */
-
-    switch ( cmd ) {
-    case SIOCAIFADDR:
-    case SIOCDIFADDR:
 	/*
-	 * If we have an appletalk sockaddr, scan forward of where
-	 * we are now on the at_ifaddr list to find one with a matching 
-	 * address on this interface.
-	 * This may leave aa pointing to the first address on the
-	 * NEXT interface!
+	 * If we have an ifp, then find the matching at_ifaddr if it exists
 	 */
-	if ( ifra->ifra_addr.sat_family == AF_APPLETALK ) {
-	    for ( ; aa; aa = aa->aa_next ) {
-		if ( aa->aa_ifp == ifp &&
-			sateqaddr( &aa->aa_addr, &ifra->ifra_addr )) {
-		    break;
+	aa = NULL;
+	AT_IFADDR_RLOCK();
+	if (ifp != NULL) {
+		TAILQ_FOREACH(aa, &at_ifaddrhead, aa_link) {
+			if (aa->aa_ifp == ifp)
+				break;
 		}
-	    }
 	}
+	if (aa != NULL)
+		ifa_ref(&aa->aa_ifa);
+	AT_IFADDR_RUNLOCK();
+
 	/*
-	 * If we a retrying to delete an addres but didn't find such,
-	 * then rewurn with an error
+	 * In this first switch table we are basically getting ready for
+	 * the second one, by getting the atalk-specific things set up
+	 * so that they start to look more similar to other protocols etc.
 	 */
-	if ( cmd == SIOCDIFADDR && aa == 0 ) {
-	    return( EADDRNOTAVAIL );
-	}
-	/*FALLTHROUGH*/
+	error = 0;
+	switch (cmd) {
+	case SIOCAIFADDR:
+	case SIOCDIFADDR:
+		/*
+		 * If we have an appletalk sockaddr, scan forward of where we
+		 * are now on the at_ifaddr list to find one with a matching 
+		 * address on this interface.  This may leave aa pointing to
+		 * the first address on the NEXT interface!
+		 */
+		if (ifra->ifra_addr.sat_family == AF_APPLETALK) {
+			struct at_ifaddr *oaa;
 
-    case SIOCSIFADDR:
-	/* 
-	 * If we are not superuser, then we don't get to do these ops.
-	 */
-	if ( suser(p) ) {
-	    return( EPERM );
-	}
+			AT_IFADDR_RLOCK();
+			for (oaa = aa; aa; aa = TAILQ_NEXT(aa, aa_link)) {
+				if (aa->aa_ifp == ifp &&
+				    sateqaddr(&aa->aa_addr, &ifra->ifra_addr))
+					break;
+			}
+			if (oaa != NULL && oaa != aa)
+				ifa_free(&oaa->aa_ifa);
+			if (aa != NULL && oaa != aa)
+				ifa_ref(&aa->aa_ifa);
+			AT_IFADDR_RUNLOCK();
+		}
+		/*
+		 * If we a retrying to delete an addres but didn't find such,
+		 * then rewurn with an error
+		 */
+		if (cmd == SIOCDIFADDR && aa == NULL) {
+			error = EADDRNOTAVAIL;
+			goto out;
+		}
+		/*FALLTHROUGH*/
 
-	sat = satosat( &ifr->ifr_addr );
-	nr = (struct netrange *)sat->sat_zero;
-	if ( nr->nr_phase == 1 ) {
-	    /*
-	     * Look for a phase 1 address on this interface.
-	     * This may leave aa pointing to the first address on the
-	     * NEXT interface!
-	     */
-	    for ( ; aa; aa = aa->aa_next ) {
-		if ( aa->aa_ifp == ifp &&
-			( aa->aa_flags & AFA_PHASE2 ) == 0 ) {
-		    break;
+	case SIOCSIFADDR:
+		/* 
+		 * If we are not superuser, then we don't get to do these ops.
+		 *
+		 * XXXRW: Layering?
+		 */
+		if (priv_check(td, PRIV_NET_ADDIFADDR)) {
+			error = EPERM;
+			goto out;
 		}
-	    }
-	} else {		/* default to phase 2 */
-	    /*
-	     * Look for a phase 2 address on this interface.
-	     * This may leave aa pointing to the first address on the
-	     * NEXT interface!
-	     */
-	    for ( ; aa; aa = aa->aa_next ) {
-		if ( aa->aa_ifp == ifp && ( aa->aa_flags & AFA_PHASE2 )) {
-		    break;
+
+		sat = satosat(&ifr->ifr_addr);
+		nr = (struct netrange *)sat->sat_zero;
+		if (nr->nr_phase == 1) {
+			struct at_ifaddr *oaa;
+
+			/*
+			 * Look for a phase 1 address on this interface.
+			 * This may leave aa pointing to the first address on
+			 * the NEXT interface!
+			 */
+			AT_IFADDR_RLOCK();
+			for (oaa = aa; aa; aa = TAILQ_NEXT(aa, aa_link)) {
+				if (aa->aa_ifp == ifp &&
+				    (aa->aa_flags & AFA_PHASE2) == 0)
+					break;
+			}
+			if (oaa != NULL && oaa != aa)
+				ifa_free(&oaa->aa_ifa);
+			if (aa != NULL && oaa != aa)
+				ifa_ref(&aa->aa_ifa);
+			AT_IFADDR_RUNLOCK();
+		} else {		/* default to phase 2 */
+			struct at_ifaddr *oaa;
+
+			/*
+			 * Look for a phase 2 address on this interface.
+			 * This may leave aa pointing to the first address on
+			 * the NEXT interface!
+			 */
+			AT_IFADDR_RLOCK();
+			for (oaa = aa; aa; aa = TAILQ_NEXT(aa, aa_link)) {
+				if (aa->aa_ifp == ifp && (aa->aa_flags &
+				    AFA_PHASE2))
+					break;
+			}
+			if (oaa != NULL && oaa != aa)
+				ifa_free(&oaa->aa_ifa);
+			if (aa != NULL && oaa != aa)
+				ifa_ref(&aa->aa_ifa);
+			AT_IFADDR_RUNLOCK();
 		}
-	    }
-	}
 
-	if ( ifp == 0 )
-	    panic( "at_control" );
+		if (ifp == NULL)
+			panic("at_control");
 
-	/*
-	 * If we failed to find an existing at_ifaddr entry, then we 
-	 * allocate a fresh one. 
-	 */
-	if ( aa == (struct at_ifaddr *) 0 ) {
-	    aa0 = malloc(sizeof(struct at_ifaddr), M_IFADDR, M_WAITOK);
-	    bzero(aa0, sizeof(struct at_ifaddr));
-	    if (( aa = at_ifaddr ) != NULL ) {
 		/*
-		 * Don't let the loopback be first, since the first
-		 * address is the machine's default address for
-		 * binding.
-		 * If it is, stick ourself in front, otherwise
-		 * go to the back of the list.
+		 * If we failed to find an existing at_ifaddr entry, then we 
+		 * allocate a fresh one. 
 		 */
-		if ( at_ifaddr->aa_ifp->if_flags & IFF_LOOPBACK ) {
-		    aa = aa0;
-		    aa->aa_next = at_ifaddr;
-		    at_ifaddr = aa;
-		} else {
-		    for ( ; aa->aa_next; aa = aa->aa_next )
-			;
-		    aa->aa_next = aa0;
-		}
-	    } else {
-		at_ifaddr = aa0;
-	    }
-	    /* 
-	     * Don't Add a reference for the aa itself!
-	     * I fell into this trap. IFAFREE tests for <=0
-	     * not <= 1 like RTFREE
-	     */
-	    /* aa->aa_ifa.ifa_refcnt++; DON'T DO THIS!! */
-	    aa = aa0;
+		if (aa == NULL) {
+			aa = malloc(sizeof(struct at_ifaddr), M_IFADDR,
+			    M_NOWAIT | M_ZERO);
+			if (aa == NULL) {
+				error = ENOBUFS;
+				goto out;
+			}
+			callout_init(&aa->aa_callout, CALLOUT_MPSAFE);
 
-	    /*
-	     * Find the end of the interface's addresses
-	     * and link our new one on the end 
-	     */
-	    ifa = (struct ifaddr *)aa;
-	    TAILQ_INSERT_TAIL(&ifp->if_addrhead, ifa, ifa_link);
+			ifa = (struct ifaddr *)aa;
+			ifa_init(ifa);
 
-	    /*
-	     * Add a reference for the linking into the ifp_if_addrlist.
-	     */
-	    ifa->ifa_refcnt++;
+			/*
+			 * As the at_ifaddr contains the actual sockaddrs,
+			 * and the ifaddr itself, link them all together
+			 * correctly.
+			 */
+			ifa->ifa_addr = (struct sockaddr *)&aa->aa_addr;
+			ifa->ifa_dstaddr = (struct sockaddr *)&aa->aa_addr;
+			ifa->ifa_netmask = (struct sockaddr *)&aa->aa_netmask;
 
-	    /*
-	     * As the at_ifaddr contains the actual sockaddrs,
-	     * and the ifaddr itself, link them al together correctly.
-	     */
-	    ifa->ifa_addr = (struct sockaddr *)&aa->aa_addr;
-	    ifa->ifa_dstaddr = (struct sockaddr *)&aa->aa_addr;
-	    ifa->ifa_netmask = (struct sockaddr *)&aa->aa_netmask;
+			/*
+			 * Set/clear the phase 2 bit.
+			 */
+			if (nr->nr_phase == 1)
+				aa->aa_flags &= ~AFA_PHASE2;
+			else
+				aa->aa_flags |= AFA_PHASE2;
 
-	    /*
-	     * Set/clear the phase 2 bit.
-	     */
-	    if ( nr->nr_phase == 1 ) {
-		aa->aa_flags &= ~AFA_PHASE2;
-	    } else {
-		aa->aa_flags |= AFA_PHASE2;
-	    }
+			ifa_ref(&aa->aa_ifa);		/* at_ifaddrhead */
+			AT_IFADDR_WLOCK();
+			if (!TAILQ_EMPTY(&at_ifaddrhead)) {
+				/*
+				 * Don't let the loopback be first, since the
+				 * first address is the machine's default
+				 * address for binding.  If it is, stick
+				 * ourself in front, otherwise go to the back
+				 * of the list.
+				 */
+				if (TAILQ_FIRST(&at_ifaddrhead)->aa_ifp->
+				    if_flags & IFF_LOOPBACK)
+					TAILQ_INSERT_HEAD(&at_ifaddrhead, aa,
+					    aa_link);
+				else
+					TAILQ_INSERT_TAIL(&at_ifaddrhead, aa,
+					    aa_link);
+			} else
+				TAILQ_INSERT_HEAD(&at_ifaddrhead, aa,
+				    aa_link);
+			AT_IFADDR_WUNLOCK();
 
- 	    /*
-	     * and link it all together
-	     */
-	    aa->aa_ifp = ifp;
-	} else {
-	    /*
-	     * If we DID find one then we clobber any routes dependent on it..
-	     */
-	    at_scrub( ifp, aa );
-	}
-	break;
+			/*
+			 * and link it all together
+			 */
+			aa->aa_ifp = ifp;
+			ifa_ref(&aa->aa_ifa);		/* if_addrhead */
+			IF_ADDR_LOCK(ifp);
+			TAILQ_INSERT_TAIL(&ifp->if_addrhead, ifa, ifa_link);
+			IF_ADDR_UNLOCK(ifp);
+		} else {
+			/*
+			 * If we DID find one then we clobber any routes
+			 * dependent on it..
+			 */
+			at_scrub(ifp, aa);
+		}
+		break;
 
-    case SIOCGIFADDR :
-	sat = satosat( &ifr->ifr_addr );
-	nr = (struct netrange *)sat->sat_zero;
-	if ( nr->nr_phase == 1 ) {
-	    /*
-	     * If the request is specifying phase 1, then
-	     * only look at a phase one address
-	     */
-	    for ( ; aa; aa = aa->aa_next ) {
-		if ( aa->aa_ifp == ifp &&
-			( aa->aa_flags & AFA_PHASE2 ) == 0 ) {
-		    break;
+	case SIOCGIFADDR :
+		sat = satosat(&ifr->ifr_addr);
+		nr = (struct netrange *)sat->sat_zero;
+		if (nr->nr_phase == 1) {
+			struct at_ifaddr *oaa;
+
+			/*
+			 * If the request is specifying phase 1, then
+			 * only look at a phase one address
+			 */
+			AT_IFADDR_RUNLOCK();
+			for (oaa = aa; aa; aa = TAILQ_NEXT(aa, aa_link)) {
+				if (aa->aa_ifp == ifp &&
+				    (aa->aa_flags & AFA_PHASE2) == 0)
+					break;
+			}
+			if (oaa != NULL && oaa != aa)
+				ifa_free(&oaa->aa_ifa);
+			if (aa != NULL && oaa != aa)
+				ifa_ref(&aa->aa_ifa);
+			AT_IFADDR_RLOCK();
+		} else {
+			struct at_ifaddr *oaa;
+
+			/*
+			 * default to phase 2
+			 */
+			AT_IFADDR_RLOCK();
+			for (oaa = aa; aa; aa = TAILQ_NEXT(aa, aa_link)) {
+				if (aa->aa_ifp == ifp && (aa->aa_flags &
+				    AFA_PHASE2))
+					break;
+			}
+			if (oaa != NULL && oaa != aa)
+				ifa_free(&oaa->aa_ifa);
+			if (aa != NULL && oaa != aa)
+				ifa_ref(&aa->aa_ifa);
+			AT_IFADDR_RUNLOCK();
 		}
-	    }
-	} else {
-	    /*
-	     * default to phase 2
-	     */
-	    for ( ; aa; aa = aa->aa_next ) {
-		if ( aa->aa_ifp == ifp && ( aa->aa_flags & AFA_PHASE2 )) {
-		    break;
+
+		if (aa == NULL) {
+			error = EADDRNOTAVAIL;
+			goto out;
 		}
-	    }
+		break;
 	}
 
-	if ( aa == (struct at_ifaddr *) 0 )
-	    return( EADDRNOTAVAIL );
-	break;
-    }
-
-    /*
-     * By the time this switch is run we should be able to assume that
-     * the "aa" pointer is valid when needed.
-     */
-    switch ( cmd ) {
-    case SIOCGIFADDR:
-
 	/*
-	 * copy the contents of the sockaddr blindly.
+	 * By the time this switch is run we should be able to assume that
+	 * the "aa" pointer is valid when needed.
 	 */
-	sat = (struct sockaddr_at *)&ifr->ifr_addr;
-	*sat = aa->aa_addr;
+	switch (cmd) {
+	case SIOCGIFADDR:
 
- 	/* 
-	 * and do some cleanups
-	 */
-	((struct netrange *)&sat->sat_zero)->nr_phase
-		= (aa->aa_flags & AFA_PHASE2) ? 2 : 1;
-	((struct netrange *)&sat->sat_zero)->nr_firstnet = aa->aa_firstnet;
-	((struct netrange *)&sat->sat_zero)->nr_lastnet = aa->aa_lastnet;
-	break;
+		/*
+		 * copy the contents of the sockaddr blindly.
+		 */
+		sat = (struct sockaddr_at *)&ifr->ifr_addr;
+		*sat = aa->aa_addr;
 
-    case SIOCSIFADDR:
-	return( at_ifinit( ifp, aa, (struct sockaddr_at *)&ifr->ifr_addr ));
+ 		/* 
+		 * and do some cleanups
+		 */
+		((struct netrange *)&sat->sat_zero)->nr_phase
+		    = (aa->aa_flags & AFA_PHASE2) ? 2 : 1;
+		((struct netrange *)&sat->sat_zero)->nr_firstnet =
+		    aa->aa_firstnet;
+		((struct netrange *)&sat->sat_zero)->nr_lastnet =
+		    aa->aa_lastnet;
+		break;
 
-    case SIOCAIFADDR:
-	if ( sateqaddr( &ifra->ifra_addr, &aa->aa_addr )) {
-	    return( 0 );
-	}
-	return( at_ifinit( ifp, aa, (struct sockaddr_at *)&ifr->ifr_addr ));
+	case SIOCSIFADDR:
+		error = at_ifinit(ifp, aa,
+		    (struct sockaddr_at *)&ifr->ifr_addr);
+		goto out;
 
-    case SIOCDIFADDR:
-	/*
-	 * scrub all routes.. didn't we just DO this? XXX yes, del it
-	 */
-	at_scrub( ifp, aa );
+	case SIOCAIFADDR:
+		if (sateqaddr(&ifra->ifra_addr, &aa->aa_addr)) {
+			error = 0;
+			goto out;
+		}
+		error = at_ifinit(ifp, aa,
+		    (struct sockaddr_at *)&ifr->ifr_addr);
+		goto out;
 
-	/*
-	 * remove the ifaddr from the interface
-	 */
-	ifa0 = (struct ifaddr *)aa;
-	TAILQ_REMOVE(&ifp->if_addrhead, ifa0, ifa_link);
+	case SIOCDIFADDR:
 
-	/*
-	 * refs goes from 1->0 if no external refs. note.. 
-	 * This will not free it ... looks for -1.
-	 */
-	IFAFREE(ifa0);
+		/*
+		 * remove the ifaddr from the interface
+		 */
+		ifa = (struct ifaddr *)aa;
+		IF_ADDR_LOCK(ifp);
+		TAILQ_REMOVE(&ifp->if_addrhead, ifa, ifa_link);
+		IF_ADDR_UNLOCK(ifp);
+		ifa_free(ifa);				/* if_addrhead */
 
-	/*
-	 * Now remove the at_ifaddr from the parallel structure
-	 * as well, or we'd be in deep trouble
-	 */
-	aa0 = aa;
-	if ( aa0 == ( aa = at_ifaddr )) {
-	    at_ifaddr = aa->aa_next;
-	} else {
-	    while ( aa->aa_next && ( aa->aa_next != aa0 )) {
-		aa = aa->aa_next;
-	    }
+		/*
+		 * Now remove the at_ifaddr from the parallel structure
+		 * as well, or we'd be in deep trouble
+		 */
 
-	    /*
-	     * if we found it, remove it, otherwise we screwed up.
-	     */
-	    if ( aa->aa_next ) {
-		aa->aa_next = aa0->aa_next;
-	    } else {
-		panic( "at_control" );
-	    }
+		AT_IFADDR_WLOCK();
+		TAILQ_REMOVE(&at_ifaddrhead, aa, aa_link);
+		AT_IFADDR_WUNLOCK();
+		ifa_free(ifa);				/* at_ifaddrhead */
+		break;
+
+	default:
+		if (ifp == NULL || ifp->if_ioctl == NULL) {
+			error = EOPNOTSUPP;
+			goto out;
+		}
+		error = ((*ifp->if_ioctl)(ifp, cmd, data));
 	}
 
-	/*
-	 * Now dump the memory we were using.
-	 * Decrement the reference count.
-	 * This should probably be the last reference
-	 * as the count will go from 0 to -1.
-	 * (unless there is still a route referencing this)
-	 */
-	IFAFREE(ifa0);
-	break;
-
-    default:
-	if ( ifp == 0 || ifp->if_ioctl == 0 )
-	    return( EOPNOTSUPP );
-	return( (*ifp->if_ioctl)( ifp, cmd, data ));
-    }
-    return( 0 );
+out:
+	if (aa != NULL)
+		ifa_free(&aa->aa_ifa);
+	return (error);
 }
 
 /* 
@@ -334,32 +394,29 @@
  * as aa->at_ifaddr.ifa_ifp should be the same.
  */
 static int
-at_scrub( ifp, aa )
-    struct ifnet	*ifp;
-    struct at_ifaddr	*aa;
+at_scrub(struct ifnet *ifp, struct at_ifaddr *aa)
 {
-    int			error;
+	int error;
 
-    if ( aa->aa_flags & AFA_ROUTE ) {
-	if (ifp->if_flags & IFF_LOOPBACK) {
-		if ((error = aa_delsingleroute(&aa->aa_ifa,
-					&aa->aa_addr.sat_addr,
-					&aa->aa_netmask.sat_addr)) != 0) {
-	    		return( error );
+	if (aa->aa_flags & AFA_ROUTE) {
+		if (ifp->if_flags & IFF_LOOPBACK) {
+			if ((error = aa_delsingleroute(&aa->aa_ifa,
+			    &aa->aa_addr.sat_addr, &aa->aa_netmask.sat_addr))
+			    != 0)
+	    			return (error);
+		} else if (ifp->if_flags & IFF_POINTOPOINT) {
+			if ((error = rtinit(&aa->aa_ifa, RTM_DELETE,
+			    RTF_HOST)) != 0)
+	    			return (error);
+		} else if (ifp->if_flags & IFF_BROADCAST) {
+			error = aa_dorangeroute(&aa->aa_ifa,
+			    ntohs(aa->aa_firstnet), ntohs(aa->aa_lastnet),
+			    RTM_DELETE);
 		}
-	} else if (ifp->if_flags & IFF_POINTOPOINT) {
-		if ((error = rtinit( &aa->aa_ifa, RTM_DELETE, RTF_HOST)) != 0)
-	    		return( error );
-	} else if (ifp->if_flags & IFF_BROADCAST) {
-		error = aa_dorangeroute(&aa->aa_ifa,
-				ntohs(aa->aa_firstnet),
-				ntohs(aa->aa_lastnet),
-				RTM_DELETE );
+		aa->aa_ifa.ifa_flags &= ~IFA_ROUTE;
+		aa->aa_flags &= ~AFA_ROUTE;
 	}
-	aa->aa_ifa.ifa_flags &= ~IFA_ROUTE;
-	aa->aa_flags &= ~AFA_ROUTE;
-    }
-    return( 0 );
+	return (0);
 }
 
 /*
